/* SPDX-License-Identifier: GPL-2.0 OR BSD-2-Clause */
/*
 * Copyright (c) 2020-2023 Senscomm Semiconductor Co., Ltd.
 *
 */
#ifndef __SCM80211_IEEE80211AX_H__
#define __SCM80211_IEEE80211AX_H__

#ifndef IEEE80211_STYPE_ACTION_NOACK
#define IEEE80211_STYPE_ACTION_NOACK	0x00E0
#endif

#ifndef IEEE80211_STYPE_TRIGGER
#define IEEE80211_STYPE_TRIGGER		0x0020
#endif

#ifndef IEEE80211_STYPE_BRPOLL
#define IEEE80211_STYPE_BRPOLL		0x0040
#endif

#ifndef IEEE80211_STYPE_VHT_NDPA
#define IEEE80211_STYPE_VHT_NDPA	0x0050
#endif

#define IEEE80211_BA_CONTROL_TYPE		GENMASK(4, 1)
#define IEEE80211_BA_CONTROL_COMPRESSED_BA	0x0004
#define IEEE80211_BA_CONTROL_MULTI_TID_BA	0x0006
#define IEEE80211_BA_CONTROL_MULTI_STA_BA	0x0016

#define IEEE80211_BA_CONTROL_TID_INFO		GENMASK(7, 4)

#if KERNEL_VERSION(5, 13, 0) > MAC80211_BASE
#define IEEE80211_HE_MAC_CAP3_MAX_AMPDU_LEN_EXP_EXT_0	\
	IEEE80211_HE_MAC_CAP3_MAX_AMPDU_LEN_EXP_USE_VHT

#define IEEE80211_HE_MAC_CAP3_MAX_AMPDU_LEN_EXP_EXT_1	\
	IEEE80211_HE_MAC_CAP3_MAX_AMPDU_LEN_EXP_VHT_1

#define IEEE80211_HE_MAC_CAP3_MAX_AMPDU_LEN_EXP_EXT_2	\
	IEEE80211_HE_MAC_CAP3_MAX_AMPDU_LEN_EXP_VHT_2

#define IEEE80211_HE_MAC_CAP4_AMSDU_IN_AMPDU		\
	IEEE80211_HE_MAC_CAP4_AMDSU_IN_AMPDU

#define IEEE80211_HE_PHY_CAP6_TRIG_SU_BEAMFORMING_FB	\
	IEEE80211_HE_PHY_CAP6_TRIG_SU_BEAMFORMER_FB

#define IEEE80211_HE_PHY_CAP6_TRIG_MU_BEAMFORMING_PARTIAL_BW_FB	\
	IEEE80211_HE_PHY_CAP6_TRIG_MU_BEAMFORMER_FB

#endif

struct ieee80211_block_ack {
	__le16 frame_control;
	__le16 duration;
	u8 ra[ETH_ALEN];
	u8 ta[ETH_ALEN];
	u8 control[2];
	u8 info[0];
};

#endif /* __SCM80211_IEEE80211AX_H__ */
